# An overlayed Nixpkgs for the Genode OS framework

This repo contains Nix expressions for building Genode with Nixpkgs and building
Nixpkgs for Genode. At the moment the former is experimental and broken in many
cases, the later is probably broken for all cases.

## Toolchain

The LLVM cross-compiler may useful already, Clang apparently builds Genode
without serious problems. Bootstrapping GCC is not feasible.

To compiler environment may be accessed via the `nix-shell` utility and the
`genode.base` attribute defined here.

```sh
nix-shell «path-to-this-repo» -A genode.base
```

Bootstrapping the environment on a laptop can take hours.

## Continuous builds

### C3D2 hydra

Hardware for continuous builds provided by [Chaos Computer Club Dresden](https://c3d2.de/).

The first hydra is located at https://hydra.hq.c3d2.de/project/genodepkgs.

The following NixOS module will enable use of this Hydra as a cache:

```nix
{ ... }: {
  nix = {
    trustedUsers = [ «your-user»  ];

    trustedBinaryCaches = [
      "https://nix-serve.hq.c3d2.de"
    ];

    binaryCachePublicKeys = [
      "nix-serve.hq.c3d2.de:FEi9GyFkou1Ua8INaEKmuGaww9E5y3XwrNGNRfKYeLo="
    ];
  };
}
```
