{ nixpkgs, genodepkgs, depot }:

import (nixpkgs + "/nixos/tests/make-test.nix") ({ pkgs, ... }:

  rec {
    name = "genode-base-linux";

    machine = { pkgs, ... }:

      {
        imports = [ ./. ];
        genode.signal-test = {
          config = ''
            <config>
            	<parent-provides>
            		<service name="ROM"/>
            		<service name="CPU"/>
            		<service name="RM"/>
            		<service name="PD"/>
            		<service name="LOG"/>
            	</parent-provides>
            	<default-route>
            		<any-service> <parent/> <any-child/> </any-service>
            	</default-route>
            	<default caps="100"/>
            	<start name="timer" caps="96">
            		<resource name="RAM" quantum="1M"/>
            		<provides><service name="Timer"/></provides>
            	</start>
            	<start name="test-signal" caps="500">
            		<resource name="RAM" quantum="10M"/>
            	</start>
            </config>
          '';
          depot = depot;
          pkgs = genodepkgs;
          rom = { "test-signal" = "${genodepkgs.os}/bin/test-signal"; };
        };
      };

    testScript = ''
      $machine->waitUntilSucceeds("journalctl -u signal-test | grep -q -i -- '--- Signalling test finished ---'");
    '';

  })
